/************************************************************************************/
/*  Program name CAPFNDEXT_REQ_SET_STAGE.sql                                        */
/*  Creater:  Chan Billy Ka Keung (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 27 JAN, 2005   CHAN Billy Ka Keung         First created                         */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID				VARCHAR2(100)	:=	'CAPFNDEXT_REQ_SET_STAGE';
	
	lv_FileName				VARCHAR2(100)	:=	'CAPFND_REQ_SET_STAGE.dat';
	lv_PathName				VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File				UTL_FILE.FILE_TYPE;
	
	lv_Scc_Count			NUMBER			:=	0;
	lv_Err_Count			NUMBER			:=	0;
	lv_Err_Msg				VARCHAR2(500)	:=	'No Error';
	
	lv_NGO_Name				VARCHAR2(100);
	lv_NGO_Count			NUMBER;
	
	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		L.*
	FROM
		FND_REQUEST_SETS_TL				A,
		FND_REQUEST_SET_STAGES			L
	WHERE	UPPER(SUBSTR(A.USER_REQUEST_SET_NAME,1,4))	=	p_NGO
	AND		A.REQUEST_SET_ID = L.REQUEST_SET_ID
	AND		A.LANGUAGE = 'US';
	
BEGIN
	lv_NGO_Name		:=	UPPER('&1');
	
	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1 THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.SET_APPLICATION_ID||CHR(9)||
				C1.REQUEST_SET_ID||CHR(9)||
				C1.REQUEST_SET_STAGE_ID||CHR(9)||
				C1.STAGE_NAME||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.CRITICAL||CHR(9)||
				C1.OUTCOME||CHR(9)||
				C1.ALLOW_CONSTRAINTS_FLAG||CHR(9)||
				C1.DISPLAY_SEQUENCE||CHR(9)||
				C1.FUNCTION_APPLICATION_ID||CHR(9)||
				C1.FUNCTION_ID||CHR(9)||
				C1.SUCCESS_LINK||CHR(9)||
				C1.WARNING_LINK||CHR(9)||
				C1.ERROR_LINK||CHR(9)||
					C1.CONCURRENT_PROGRAM_ID||CHR(9)||
				C1.X||CHR(9)||
				C1.Y||CHR(9)||
				C1.ICON_NAME||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetFNDConcPrgName(C1.CONCURRENT_PROGRAM_ID)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO_Name||': No request sets for this business group';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;
	
	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
